std::unique_ptr< _Tp[], _Dp > Class Template Reference
Pointer Abstractions

## Public Types

typedef _Dp | deleter_type
typedef _Tp | element_type
typedef _Pointer::type | pointer

## Public Member Functions

constexpr | unique_ptr () noexcept
| unique_ptr (pointer __p) noexcept
template<typename _Up , typename = _Require<is_pointer<pointer>, is_convertible<_Up*, pointer>, __is_derived_Tp<_Up>>>
| unique_ptr (_Up *__p)=delete
| unique_ptr (pointer __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type __d) noexcept
| unique_ptr (pointer __p, typename remove_reference< deleter_type >::type &&__d) noexcept
| unique_ptr (unique_ptr &&__u) noexcept
constexpr | unique_ptr (nullptr_t) noexcept
template<typename _Up , typename _Ep , typename = _Require<__safe_conversion<_Up, _Ep>, typename conditional<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>::type >>
| unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
| unique_ptr (const unique_ptr &)=delete
template<typename _Up , typename = _Require<is_pointer<pointer>, is_convertible<_Up*, pointer>, __is_derived_Tp<_Up>>>
| unique_ptr (_Up *, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type)=delete
template<typename _Up , typename = _Require<is_pointer<pointer>, is_convertible<_Up*, pointer>, __is_derived_Tp<_Up>>>
| unique_ptr (_Up *, typename remove_reference< deleter_type >::type &&)=delete
| ~unique_ptr ()
pointer | get () const noexcept
deleter_type & | get_deleter () noexcept
const deleter_type & | get_deleter () const noexcept
| operator bool () const noexcept
unique_ptr & | operator= (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep >
enable_if< __safe_conversion < _Up, _Ep >::value, unique_ptr & >::type | operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
unique_ptr & | operator= (nullptr_t) noexcept
unique_ptr & | operator= (const unique_ptr &)=delete
std::add_lvalue_reference < element_type >::type | operator[] (size_t __i) const
pointer | release () noexcept
void | reset (pointer __p=pointer()) noexcept
template<typename _Up , typename = _Require<is_pointer<pointer>, is_convertible<_Up*, pointer>, __is_derived_Tp<_Up>>>
void | reset (_Up *)=delete
void | swap (unique_ptr &__u) noexcept

## Detailed Description

### template<typename _Tp, typename _Dp>
class std::unique_ptr< _Tp[], _Dp >

20.7.1.3 unique_ptr for array objects with a runtime length

Definition at line 365 of file unique_ptr.h.

## Constructor & Destructor Documentation

template<typename _Tp , typename _Dp >

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( |  | ) |

inlinenoexcept

Default constructor, creates a unique_ptr that owns nothing.

Definition at line 414 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | pointer | __p | ) |

inlineexplicitnoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of `element_type`

The deleter will be value-initialized.

Definition at line 426 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | pointer | __p,
|  | typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type | __d
| ) |  |

inlinenoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `__d`

Definition at line 444 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | pointer | __p,
|  | typename remove_reference< deleter_type >::type && | __d
| ) |  |

inlinenoexcept

Takes ownership of a pointer.

Parameters

  __p | A pointer to an array of `element_type`
  __d | A reference to a deleter.

The deleter will be initialized with `std::move(__d)`

Definition at line 456 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | unique_ptr< _Tp[], _Dp > && | __u | ) |

inlinenoexcept

Move constructor.

Definition at line 463 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

constexpr std::unique_ptr< _Tp[], _Dp >::unique_ptr | ( | nullptr_t |  | ) |

inlinenoexcept

Creates a unique_ptr that owns nothing.

Definition at line 467 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::~unique_ptr | ( |  | ) |

inline

Destructor, invokes the deleter if the stored pointer is not null.

Definition at line 480 of file unique_ptr.h.

References std::unique_ptr< _Tp, _Dp >::get_deleter().

## Member Function Documentation

template<typename _Tp , typename _Dp >

pointer std::unique_ptr< _Tp[], _Dp >::get | ( | void |  | ) | const

inlinenoexcept

Return the stored pointer.

Definition at line 541 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

deleter_type& std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) |

inlinenoexcept

Return a reference to the stored deleter.

Definition at line 546 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

const deleter_type& std::unique_ptr< _Tp[], _Dp >::get_deleter | ( |  | ) | const

inlinenoexcept

Return a reference to the stored deleter.

Definition at line 551 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

std::unique_ptr< _Tp[], _Dp >::operator bool | ( |  | ) | const

inlineexplicitnoexcept

Return `true` if the stored pointer is not null.

Definition at line 555 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

unique_ptr& std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Tp[], _Dp > && | __u | ) |

inlinenoexcept

Move assignment operator.

Parameters

  __u | The object to transfer ownership from.

Invokes the deleter first if this object owns a pointer.

Definition at line 497 of file unique_ptr.h.

References std::unique_ptr< _Tp, _Dp >::get_deleter(), and std::unique_ptr< _Tp, _Dp >::reset().

template<typename _Tp , typename _Dp >
template<typename _Up , typename _Ep >

enable_if<__safe_conversion<_Up, _Ep>::value, unique_ptr&>::type std::unique_ptr< _Tp[], _Dp >::operator= | ( | unique_ptr< _Up, _Ep > && | __u | ) |

inlinenoexcept

Assignment from another type.

Parameters

  __u | The object to transfer ownership from, which owns a convertible pointer to an array object.

Invokes the deleter first if this object owns a pointer.

Definition at line 514 of file unique_ptr.h.

References std::unique_ptr< _Tp, _Dp >::get_deleter(), and std::unique_ptr< _Tp, _Dp >::reset().

template<typename _Tp , typename _Dp >

unique_ptr& std::unique_ptr< _Tp[], _Dp >::operator= | ( | nullptr_t |  | ) |

inlinenoexcept

Reset the unique_ptr to empty, invoking the deleter if necessary.

Definition at line 523 of file unique_ptr.h.

References std::unique_ptr< _Tp, _Dp >::reset().

template<typename _Tp , typename _Dp >

std::add_lvalue_reference<element_type>::type std::unique_ptr< _Tp[], _Dp >::operator[] | ( | size_t | __i | ) | const

inline

Access an element of owned array.

Definition at line 533 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

pointer std::unique_ptr< _Tp[], _Dp >::release | ( |  | ) |

inlinenoexcept

Release ownership of any stored pointer.

Definition at line 562 of file unique_ptr.h.

template<typename _Tp , typename _Dp >

void std::unique_ptr< _Tp[], _Dp >::reset | ( | pointer | __p = `pointer()` | ) |

inlinenoexcept

Replace the stored pointer.

Parameters

  __p | The new pointer to store.

The deleter will be invoked if a pointer is already owned.

Definition at line 576 of file unique_ptr.h.

References std::unique_ptr< _Tp, _Dp >::get_deleter(), and std::unique_ptr< _Tp, _Dp >::swap().

template<typename _Tp , typename _Dp >

void std::unique_ptr< _Tp[], _Dp >::swap | ( | unique_ptr< _Tp[], _Dp > & | __u | ) |

inlinenoexcept

Exchange the pointer and deleter with another object.

Definition at line 591 of file unique_ptr.h.

References std::unique_ptr< _Tp, _Dp >::swap().

The documentation for this class was generated from the following file:

- unique_ptr.h